unit Unit2;

interface

uses
  IdBaseComponent, IdComponent, IdRawBase, IdRawClient,
  IdIcmpClient, Classes, Forms;

type
  Ping = class(TThread)
  private
    { Private declarations }
    icmp:TIdIcmpClient;
    delay:word;
    form:TForm;
    procedure ping;
    procedure icmpReply(ASender: TComponent;
      const AReplyStatus: TReplyStatus);
  protected
    procedure Execute; override;
  public
    constructor create(d:word; f:TForm);
    // d=delay between pings
  end;

implementation

uses SysUtils, unit1;

{ Important: Methods and properties of objects in visual components can only be
  used in a method called using Synchronize, for example,

      Synchronize(UpdateCaption);

  and UpdateCaption could look like,

    procedure Ping.UpdateCaption;
    begin
      Form1.Caption := 'Updated in a thread';
    end; }

{ Ping }

const tostring1:array[TReplyStatusTypes] of string=('An echo was received.',
                                                    'An error has occured.',
                                                    'TimeOut',
                                                    'Host unreachable',
                                                    'Time-To-Live exceeded');

procedure Ping.Execute;
var delta:byte;
begin
  { Place thread code here }
  while not terminated do
  begin
    for delta:=1 to delay div 200 do
    begin
      if terminated then exit;
      sleep(200);
    end;
    sleep(delay mod 200);
    Synchronize(ping);
  end;
end;

procedure Ping.ping;
begin
  icmp.Host:=(form as TForm1).edit1.text;
  icmp.Ping('ciuly');
end;

constructor Ping.create(d:word; f:TForm);
begin
  delay:=d;
  form:=f;
  icmp:=TIdIcmpClient.Create(nil);
  icmp.OnReply:=icmpReply;
  FreeOnTerminate:=true;
  inherited create(false);
end;

function tostring(status:TReplyStatus):string;
begin
  result:=tostring1[status.ReplyStatusType];
end;

procedure ping.icmpReply(ASender: TComponent;
  const AReplyStatus: TReplyStatus);
begin
  with form as TForm1 do
  begin
    memo1.lines.add('reply from '+icmp.Host+' : '+tostring(AReplyStatus));
    if AReplyStatus.ReplyStatusType=rsEcho then CoolTrayIcon1.IconIndex:=1
                                           else CoolTrayIcon1.IconIndex:=0;
  end;
end;

end.
 